import csv
import seaborn as sns;
sns.set_context('paper', font_scale=1.5)
sns.set_style('whitegrid', {
    'legend.frameon': True,
    'axes.facecolor': 'white',
    'axes.edgecolor': '.1',
    'font.family': 'serif',
    'font.serif': ['computer modern roman'],
    'dpi': 200
})

import matplotlib as mpl
import matplotlib.pyplot as plt
import pandas as pd
# sns.set_context('paper')
p = 'cummulative.csv'
# entries = []
# with open(p, 'r') as csvfile:
#     reader = csv.DictReader(csvfile)
#     for row in reader:
#         print(row)
#         method = row['Method']
#         for k, v in row.items():
#             if k == 'Method':
#                 continue
#             metric, typ = k.split(' ')
#             typ = typ[1:-1].capitalize()
#             entries.append({
#                 'Method': method,
#                 'Metric': metric,
#                 'Value': float(v)
#             })
data_c = pd.DataFrame.from_csv(p)
print(data_c)
data_c = pd.melt(data_c, id_vars=['Metric'], value_vars=['SII', 'SC', 'Ours'], var_name='Method')
print(data_c)

sns.set_palette(['#d95f02', '#984ea3', '#4daf4a'], n_colors=3)
g = sns.factorplot(x='Metric', y='value', hue='Method', data=data_c, kind='bar',
                   legend=False, legend_out=False, size=2.5, aspect=1.5,
                   ci=None, alpha=0.92, saturation=10, hue_order=['SC', 'SII', 'Ours'])

# plt.legend(bbox_to_anchor=(1.05, 1), loc=2, borderaxespad=0.)
g.set_xlabels('')
g.set_ylabels('')
g.set_titles(template='{col_name}', y=0.75)
# g.set_xticklabels(rotation=10)
myLegend = plt.legend(bbox_to_anchor=[1., 1.15], prop={'size': 10},
                      loc=1, ncol=3)  # left, bottom, width, height
#title=r'TOTAL ACCURACY AND PER STAGE-RANDOM FOREST')
plt.subplots_adjust(top=0.9, bottom=0.1, left=0.1, right=0.96)
plt.show()
sys.exit(0)

p = 'mockup-cvpr.csv'

entries = []
with open(p, 'r') as csvfile:
    reader = csv.DictReader(csvfile)
    for row in reader:
        print(row)
        method = row['Method']
        for k, v in row.items():
            if k == 'Method':
                continue
            metric, typ = k.split(' ')
            typ = typ[1:-1].capitalize()
            entries.append({
                'Method': method,
                # 'Metric': "%s\n%s" % (metric, typ),
                'Metric': metric,
                'Type': typ,
                'Value': float(v)
            })
# print(data)
data = pd.DataFrame.from_dict(entries)
# data = pd.read_csv(p)u
print(data)
# colors = ["windows blue", "amber", "faded green", "dusty purple"]
# sns.set(font_scale=1.1)
# sns.set_palette('Set1', n_colors=3)
sns.set_palette(['#ff7f00', '#377eb8', '#4daf4a'], n_colors=3)
g = sns.factorplot(x='Metric', y='Value', hue='Method', data=data, kind='bar',
                   legend=False, legend_out=False, size=3., aspect=2.,
                   ci=None, col='Type', alpha=0.9, saturation=5)

# plt.legend(bbox_to_anchor=(1.05, 1), loc=2, borderaxespad=0.)
g.set_xlabels('')
g.set_ylabels('')
g.set_titles(template='{col_name}', y=0.75)
g.set_xticklabels(rotation=10)
myLegend = plt.legend(bbox_to_anchor=[1., 1.15], prop={'size': 10},
                      loc=1, ncol=3)  # left, bottom, width, height
                      #title=r'TOTAL ACCURACY AND PER STAGE-RANDOM FOREST')
# myLegend.get_title().set_fontsize('20')
# for col in range(len(g.col_names)):
#     print("col: %d, %s" % (col, g.col_names[col]))
#     ax = g.facet_axis(0, col)
#     print(ax.get_title())
#     ax.set_title(ax.get_title(), fontsize=30)
# plt.subplots_adjust(top=0.94, bottom=0.14)
ax = plt.gca()
# ax.set_xlabel('')
# ax.set_ylabel('')
# g.set(axis_bgcolor='w')
for a in dir(g):
    print(a)
plt.show()
# https://stackoverflow.com/questions/39519609/annotate-bars-with-values-on-pandas-on-seaborn-factorplot-bar-plot
